Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 511)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 512)
@@ -1327,298 +1435,368 @@
      * Parsing inputs provided as KVP
      */
-    r_inputs=getMap(request_inputs,"DataInputs");
-#ifdef DEBUG
-    fprintf(stderr,"DATA INPUTS [%s]\n",r_inputs->value);
-#endif
-    char cursor_input[40960];
-    if(r_inputs!=NULL)
-      snprintf(cursor_input,40960,"%s",r_inputs->value);
-    else{
-      errorException(m, _("Parameter <DataInputs> was not specified"),"MissingParameterValue","DataInputs");
-      freeMaps(&m);
-      free(m);
-      free(REQUEST);
-      free(SERVICE_URL);
-      InternetCloseHandle(&hInternet);
-      freeService(&s1);
-      free(s1);
-      return 0;
-    }
-    j=0;
-  
+      r_inputs = getMap (request_inputs, "DataInputs");
+#ifdef DEBUG
+      fprintf (stderr, "DATA INPUTS [%s]\n", r_inputs->value);
+#endif
+      char cursor_input[40960];
+      if (r_inputs != NULL)
+        snprintf (cursor_input, 40960, "%s", r_inputs->value);
+      else
+        {
+          errorException (m, _("Parameter <DataInputs> was not specified"),
+                          "MissingParameterValue", "DataInputs");
+          freeMaps (&m);
+          free (m);
+          free (REQUEST);
+          free (SERVICE_URL);
+          InternetCloseHandle (&hInternet);
+          freeService (&s1);
+          free (s1);
+          return 0;
+        }
+      j = 0;
+
     /**
      * Put each DataInputs into the inputs_as_text array
      */
-    char *tmp1=zStrdup(cursor_input);
-    char * pToken;
-    pToken=strtok(cursor_input,";");
-    if(pToken!=NULL && strncasecmp(pToken,tmp1,strlen(tmp1))==0){
-      char* tmp2=url_decode(tmp1);
-      snprintf(cursor_input,(strlen(tmp2)+1)*sizeof(char),"%s",tmp2);
-      free(tmp2);
-      pToken=strtok(cursor_input,";");
-    }
-    free(tmp1);
-
-    char** inputs_as_text=(char**)malloc(100*sizeof(char*));
-    if(inputs_as_text == NULL){
-      return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-    }
-    i=0;
-    while(pToken!=NULL){
-#ifdef DEBUG
-      fprintf(stderr,"***%s***\n",pToken);
-#endif
-      fflush(stderr);
-#ifdef DEBUG
-      fprintf(stderr,"***%s***\n",pToken);
-#endif
-      inputs_as_text[i]=(char*)malloc((strlen(pToken)+1)*sizeof(char));
-      snprintf(inputs_as_text[i],strlen(pToken)+1,"%s",pToken);
-      if(inputs_as_text[i] == NULL){
-	return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-      }
-      pToken = strtok(NULL,";");
-      i++;
-    }
-
-    for(j=0;j<i;j++){
-      char *tmp=zStrdup(inputs_as_text[j]);
-      free(inputs_as_text[j]);
-      char *tmpc;
-      tmpc=strtok(tmp,"@");
-      while(tmpc!=NULL){
-#ifdef DEBUG
-	fprintf(stderr,"***\n***%s***\n",tmpc);
-#endif
-	char *tmpv=strstr(tmpc,"=");
-	char tmpn[256];
-	memset(tmpn,0,256);
-	if(tmpv!=NULL){
-	  strncpy(tmpn,tmpc,(strlen(tmpc)-strlen(tmpv))*sizeof(char));
-	  tmpn[strlen(tmpc)-strlen(tmpv)]=0;
-	}
-	else{
-	  strncpy(tmpn,tmpc,strlen(tmpc)*sizeof(char));
-	  tmpn[strlen(tmpc)]=0;
-	}
-#ifdef DEBUG
-	fprintf(stderr,"***\n*** %s = %s ***\n",tmpn,tmpv+1);
-#endif
-	if(tmpmaps==NULL){
-	  tmpmaps=(maps*)malloc(MAPS_SIZE);
-	  if(tmpmaps == NULL){
-	    return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-	  }
-	  tmpmaps->name=zStrdup(tmpn);
-	  if(tmpv!=NULL){
-	    char *tmpvf=url_decode(tmpv+1);
-	    tmpmaps->content=createMap("value",tmpvf);
-	    free(tmpvf);
-	  }
-	  else
-	    tmpmaps->content=createMap("value","Reference");
-	  tmpmaps->next=NULL;
-	}
-	tmpc=strtok(NULL,"@");
-	while(tmpc!=NULL){
-#ifdef DEBUG
-	  fprintf(stderr,"*** KVP NON URL-ENCODED \n***%s***\n",tmpc);
-#endif
-	  char *tmpv1=strstr(tmpc,"=");
-#ifdef DEBUG
-	  fprintf(stderr,"*** VALUE NON URL-ENCODED \n***%s***\n",tmpv1+1);
-#endif
-	  char tmpn1[1024];
-	  memset(tmpn1,0,1024);
-	  if(tmpv1!=NULL){
-	    strncpy(tmpn1,tmpc,strlen(tmpc)-strlen(tmpv1));
-	    tmpn1[strlen(tmpc)-strlen(tmpv1)]=0;
-	    addToMap(tmpmaps->content,tmpn1,tmpv1+1);
-	  }
-	  else{
-	    strncpy(tmpn1,tmpc,strlen(tmpc));
-	    tmpn1[strlen(tmpc)]=0;
-	    map* lmap=getLastMap(tmpmaps->content);
-	    char *tmpValue=(char*)malloc((strlen(tmpv)+strlen(tmpc)+1)*sizeof(char));
-	    sprintf(tmpValue,"%s@%s",tmpv+1,tmpc);
-	    free(lmap->value);
-	    lmap->value=zStrdup(tmpValue);
-	    free(tmpValue);
-	    tmpc=strtok(NULL,"@");
-	    continue;
-	  }
-#ifdef DEBUG
-	  fprintf(stderr,"*** NAME NON URL-ENCODED \n***%s***\n",tmpn1);
-	  fprintf(stderr,"*** VALUE NON URL-ENCODED \n***%s***\n",tmpv1+1);
-#endif
-	  if(strcmp(tmpn1,"xlink:href")!=0)
-	    addToMap(tmpmaps->content,tmpn1,tmpv1+1);
-	  else
-	    if(tmpv1!=NULL){
-	      char *tmpx2=url_decode(tmpv1+1);
-	      if(strncasecmp(tmpx2,"http://",7)!=0 &&
-		 strncasecmp(tmpx2,"ftp://",6)!=0 &&
-		 strncasecmp(tmpx2,"https://",8)!=0){
-		char emsg[1024];
-		sprintf(emsg,_("Unable to find a valid protocol to download the remote file %s"),tmpv1+1);
-		errorException(m,emsg,"InternalError",NULL);
-		freeMaps(&m);
-		free(m);
-		free(REQUEST);
-		free(SERVICE_URL);
-		InternetCloseHandle(&hInternet);
-		freeService(&s1);
-		free(s1);
-		return 0;
-	      }
-#ifdef DEBUG
-	      fprintf(stderr,"REQUIRE TO DOWNLOAD A FILE FROM A SERVER : url(%s)\n",tmpv1+1);
-#endif
-	      addToMap(tmpmaps->content,tmpn1,tmpx2);	      
+      char *tmp1 = zStrdup (cursor_input);
+      char *pToken;
+      pToken = strtok (cursor_input, ";");
+      if (pToken != NULL && strncasecmp (pToken, tmp1, strlen (tmp1)) == 0)
+        {
+          char *tmp2 = url_decode (tmp1);
+          snprintf (cursor_input, (strlen (tmp2) + 1) * sizeof (char), "%s",
+                    tmp2);
+          free (tmp2);
+          pToken = strtok (cursor_input, ";");
+        }
+      free (tmp1);
+
+      char **inputs_as_text = (char **) malloc (100 * sizeof (char *));
+      if (inputs_as_text == NULL)
+        {
+          return errorException (m, _("Unable to allocate memory."),
+                                 "InternalError", NULL);
+        }
+      i = 0;
+      while (pToken != NULL)
+        {
+#ifdef DEBUG
+          fprintf (stderr, "***%s***\n", pToken);
+#endif
+          fflush (stderr);
+#ifdef DEBUG
+          fprintf (stderr, "***%s***\n", pToken);
+#endif
+          inputs_as_text[i] =
+            (char *) malloc ((strlen (pToken) + 1) * sizeof (char));
+          snprintf (inputs_as_text[i], strlen (pToken) + 1, "%s", pToken);
+          if (inputs_as_text[i] == NULL)
+            {
+              return errorException (m, _("Unable to allocate memory."),
+                                     "InternalError", NULL);
+            }
+          pToken = strtok (NULL, ";");
+          i++;
+        }
+
+      for (j = 0; j < i; j++)
+        {
+          char *tmp = zStrdup (inputs_as_text[j]);
+          free (inputs_as_text[j]);
+          char *tmpc;
+          tmpc = strtok (tmp, "@");
+          while (tmpc != NULL)
+            {
+#ifdef DEBUG
+              fprintf (stderr, "***\n***%s***\n", tmpc);
+#endif
+              char *tmpv = strstr (tmpc, "=");
+              char tmpn[256];
+              memset (tmpn, 0, 256);
+              if (tmpv != NULL)
+                {
+                  strncpy (tmpn, tmpc,
+                           (strlen (tmpc) - strlen (tmpv)) * sizeof (char));
+                  tmpn[strlen (tmpc) - strlen (tmpv)] = 0;
+                }
+              else
+                {
+                  strncpy (tmpn, tmpc, strlen (tmpc) * sizeof (char));
+                  tmpn[strlen (tmpc)] = 0;
+                }
+#ifdef DEBUG
+              fprintf (stderr, "***\n*** %s = %s ***\n", tmpn, tmpv + 1);
+#endif
+              if (tmpmaps == NULL)
+                {
+                  tmpmaps = (maps *) malloc (MAPS_SIZE);
+                  if (tmpmaps == NULL)
+                    {
+                      return errorException (m,
+                                             _("Unable to allocate memory."),
+                                             "InternalError", NULL);
+                    }
+                  tmpmaps->name = zStrdup (tmpn);
+                  if (tmpv != NULL)
+                    {
+                      char *tmpvf = url_decode (tmpv + 1);
+                      tmpmaps->content = createMap ("value", tmpvf);
+                      free (tmpvf);
+                    }
+                  else
+                    tmpmaps->content = createMap ("value", "Reference");
+                  tmpmaps->next = NULL;
+                }
+              tmpc = strtok (NULL, "@");
+              while (tmpc != NULL)
+                {
+#ifdef DEBUG
+                  fprintf (stderr, "*** KVP NON URL-ENCODED \n***%s***\n",
+                           tmpc);
+#endif
+                  char *tmpv1 = strstr (tmpc, "=");
+#ifdef DEBUG
+                  fprintf (stderr, "*** VALUE NON URL-ENCODED \n***%s***\n",
+                           tmpv1 + 1);
+#endif
+                  char tmpn1[1024];
+                  memset (tmpn1, 0, 1024);
+                  if (tmpv1 != NULL)
+                    {
+                      strncpy (tmpn1, tmpc, strlen (tmpc) - strlen (tmpv1));
+                      tmpn1[strlen (tmpc) - strlen (tmpv1)] = 0;
+                      addToMap (tmpmaps->content, tmpn1, tmpv1 + 1);
+                    }
+                  else
+                    {
+                      strncpy (tmpn1, tmpc, strlen (tmpc));
+                      tmpn1[strlen (tmpc)] = 0;
+                      map *lmap = getLastMap (tmpmaps->content);
+                      char *tmpValue =
+                        (char *) malloc ((strlen (tmpv) + strlen (tmpc) + 1) *
+                                         sizeof (char));
+                      sprintf (tmpValue, "%s@%s", tmpv + 1, tmpc);
+                      free (lmap->value);
+                      lmap->value = zStrdup (tmpValue);
+                      free (tmpValue);
+                      tmpc = strtok (NULL, "@");
+                      continue;
+                    }
+#ifdef DEBUG
+                  fprintf (stderr, "*** NAME NON URL-ENCODED \n***%s***\n",
+                           tmpn1);
+                  fprintf (stderr, "*** VALUE NON URL-ENCODED \n***%s***\n",
+                           tmpv1 + 1);
+#endif
+                  if (strcmp (tmpn1, "xlink:href") != 0)
+                    addToMap (tmpmaps->content, tmpn1, tmpv1 + 1);
+                  else if (tmpv1 != NULL)
+                    {
+                      char *tmpx2 = url_decode (tmpv1 + 1);
+                      if (strncasecmp (tmpx2, "http://", 7) != 0 &&
+                          strncasecmp (tmpx2, "ftp://", 6) != 0 &&
+                          strncasecmp (tmpx2, "https://", 8) != 0)
+                        {
+                          char emsg[1024];
+                          sprintf (emsg,
+                                   _
+                                   ("Unable to find a valid protocol to download the remote file %s"),
+                                   tmpv1 + 1);
+                          errorException (m, emsg, "InternalError", NULL);
+                          freeMaps (&m);
+                          free (m);
+                          free (REQUEST);
+                          free (SERVICE_URL);
+                          InternetCloseHandle (&hInternet);
+                          freeService (&s1);
+                          free (s1);
+                          return 0;
+                        }
+#ifdef DEBUG
+                      fprintf (stderr,
+                               "REQUIRE TO DOWNLOAD A FILE FROM A SERVER : url(%s)\n",
+                               tmpv1 + 1);
+#endif
+                      addToMap (tmpmaps->content, tmpn1, tmpx2);
 #ifndef WIN32
-	      if(CHECK_INET_HANDLE(hInternet))
-#endif
-		{
-		  if(loadRemoteFile(&m,&tmpmaps->content,&hInternet,tmpx2)<0){
-		    freeMaps(&m);
-		    free(m);
-		    free(REQUEST);
-		    free(SERVICE_URL);
-		    InternetCloseHandle(&hInternet);
-		    freeService(&s1);
-		    free(s1);
-		    return 0;
-		  }
-		}
-	      free(tmpx2);
-	      addToMap(tmpmaps->content,"Reference",tmpv1+1);
-	    }
-	  tmpc=strtok(NULL,"@");
-	}
-#ifdef DEBUG
-	dumpMaps(tmpmaps);
-	fflush(stderr);
-#endif
-	if(request_input_real_format==NULL)
-	  request_input_real_format=dupMaps(&tmpmaps);
-	else{
-	  maps* testPresence=getMaps(request_input_real_format,tmpmaps->name);
-	  if(testPresence!=NULL){
-	    elements* elem=getElements(s1->inputs,tmpmaps->name);
-	    if(elem!=NULL){
-	      if(appendMapsToMaps(m,request_input_real_format,tmpmaps,elem)<0){
-		freeMaps(&m);
-		free(m);
-		free(REQUEST);
-		free(SERVICE_URL);
-		InternetCloseHandle(&hInternet);
-		freeService(&s1);
-		free(s1);
-		return 0;
-	      }
-	    }
-	  }
-	  else
-	    addMapsToMaps(&request_input_real_format,tmpmaps);
-	}
-	freeMaps(&tmpmaps);
-	free(tmpmaps);
-	tmpmaps=NULL;
-	free(tmp);
-      }
-    }
-    free(inputs_as_text);
-  }
-  else {
+                      if (CHECK_INET_HANDLE (hInternet))
+#endif
+                        {
+                          if (loadRemoteFile
+                              (&m, &tmpmaps->content, &hInternet, tmpx2) < 0)
+                            {
+                              freeMaps (&m);
+                              free (m);
+                              free (REQUEST);
+                              free (SERVICE_URL);
+                              InternetCloseHandle (&hInternet);
+                              freeService (&s1);
+                              free (s1);
+                              return 0;
+                            }
+                        }
+                      free (tmpx2);
+                      addToMap (tmpmaps->content, "Reference", tmpv1 + 1);
+                    }
+                  tmpc = strtok (NULL, "@");
+                }
+#ifdef DEBUG
+              dumpMaps (tmpmaps);
+              fflush (stderr);
+#endif
+              if (request_input_real_format == NULL)
+                request_input_real_format = dupMaps (&tmpmaps);
+              else
+                {
+                  maps *testPresence =
+                    getMaps (request_input_real_format, tmpmaps->name);
+                  if (testPresence != NULL)
+                    {
+                      elements *elem =
+                        getElements (s1->inputs, tmpmaps->name);
+                      if (elem != NULL)
+                        {
+                          if (appendMapsToMaps
+                              (m, request_input_real_format, tmpmaps,
+                               elem) < 0)
+                            {
+                              freeMaps (&m);
+                              free (m);
+                              free (REQUEST);
+                              free (SERVICE_URL);
+                              InternetCloseHandle (&hInternet);
+                              freeService (&s1);
+                              free (s1);
+                              return 0;
+                            }
+                        }
+                    }
+                  else
+                    addMapsToMaps (&request_input_real_format, tmpmaps);
+                }
+              freeMaps (&tmpmaps);
+              free (tmpmaps);
+              tmpmaps = NULL;
+              free (tmp);
+            }
+        }
+      free (inputs_as_text);
+    }
+  else
+    {
     /**
      * Parse XML request
-     */ 
-    xmlInitParser();
-#ifdef DEBUG
-    fflush(stderr);
-    fprintf(stderr,"BEFORE %s\n",postRequest->value);
-    fflush(stderr);
-#endif
-    xmlDocPtr doc =
-      xmlParseMemory(postRequest->value,cgiContentLength);
-#ifdef DEBUG
-    fprintf(stderr,"AFTER\n");
-    fflush(stderr);
+     */
+      xmlInitParser ();
+#ifdef DEBUG
+      fflush (stderr);
+      fprintf (stderr, "BEFORE %s\n", postRequest->value);
+      fflush (stderr);
+#endif
+      xmlDocPtr doc = xmlParseMemory (postRequest->value, cgiContentLength);
+#ifdef DEBUG
+      fprintf (stderr, "AFTER\n");
+      fflush (stderr);
 #endif
     /**
      * Parse every Input in DataInputs node.
      */
-    xmlXPathObjectPtr tmpsptr=extractFromDoc(doc,"/*/*/*[local-name()='Input']");
-    xmlNodeSet* tmps=tmpsptr->nodesetval;
-#ifdef DEBUG
-    fprintf(stderr,"*****%d*****\n",tmps->nodeNr);
-#endif
-    for(int k=0;k<tmps->nodeNr;k++){
-      maps *tmpmaps=NULL;
-      xmlNodePtr cur=tmps->nodeTab[k];
-      if(tmps->nodeTab[k]->type == XML_ELEMENT_NODE) {
-	/**
+      xmlXPathObjectPtr tmpsptr =
+        extractFromDoc (doc, "/*/*/*[local-name()='Input']");
+      xmlNodeSet *tmps = tmpsptr->nodesetval;
+#ifdef DEBUG
+      fprintf (stderr, "*****%d*****\n", tmps->nodeNr);
+#endif
+      for (int k = 0; k < tmps->nodeNr; k++)
+        {
+          maps *tmpmaps = NULL;
+          xmlNodePtr cur = tmps->nodeTab[k];
+          if (tmps->nodeTab[k]->type == XML_ELEMENT_NODE)
+            {
+        /**
 	 * A specific Input node.
 	 */
 #ifdef DEBUG
-	fprintf(stderr, "= element 0 node \"%s\"\n", cur->name);
-#endif
-	xmlNodePtr cur2=cur->children;
-	while(cur2!=NULL){
-	  while(cur2!=NULL && cur2->type!=XML_ELEMENT_NODE)
-	    cur2=cur2->next;
-	  if(cur2==NULL)
-	    break;
-	  /**
+              fprintf (stderr, "= element 0 node \"%s\"\n", cur->name);
+#endif
+              xmlNodePtr cur2 = cur->children;
+              while (cur2 != NULL)
+                {
+                  while (cur2 != NULL && cur2->type != XML_ELEMENT_NODE)
+                    cur2 = cur2->next;
+                  if (cur2 == NULL)
+                    break;
+          /**
 	   * Indentifier
 	   */
-	  if(xmlStrncasecmp(cur2->name,BAD_CAST "Identifier",xmlStrlen(cur2->name))==0){
-	    xmlChar *val= xmlNodeListGetString(doc,cur2->xmlChildrenNode,1);
-	    if(tmpmaps==NULL){
-	      tmpmaps=(maps*)malloc(MAPS_SIZE);
-	      if(tmpmaps == NULL){
-		return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-	      }
-	      tmpmaps->name=zStrdup((char*)val);
-	      tmpmaps->content=NULL;
-	      tmpmaps->next=NULL;
-	    }
-	    xmlFree(val);
-	  }
-	  /**
+                  if (xmlStrncasecmp
+                      (cur2->name, BAD_CAST "Identifier",
+                       xmlStrlen (cur2->name)) == 0)
+                    {
+                      xmlChar *val =
+                        xmlNodeListGetString (doc, cur2->xmlChildrenNode, 1);
+                      if (tmpmaps == NULL)
+                        {
+                          tmpmaps = (maps *) malloc (MAPS_SIZE);
+                          if (tmpmaps == NULL)
+                            {
+                              return errorException (m,
+                                                     _
+                                                     ("Unable to allocate memory."),
+                                                     "InternalError", NULL);
+                            }
+                          tmpmaps->name = zStrdup ((char *) val);
+                          tmpmaps->content = NULL;
+                          tmpmaps->next = NULL;
+                        }
+                      xmlFree (val);
+                    }
+          /**
 	   * Title, Asbtract
 	   */
-	  if(xmlStrncasecmp(cur2->name,BAD_CAST "Title",xmlStrlen(cur2->name))==0 ||
-	     xmlStrncasecmp(cur2->name,BAD_CAST "Abstract",xmlStrlen(cur2->name))==0){
-	    xmlChar *val=
-	      xmlNodeListGetString(doc,cur2->xmlChildrenNode,1);
-	    if(tmpmaps==NULL){
-	      tmpmaps=(maps*)malloc(MAPS_SIZE);
-	      if(tmpmaps == NULL){
-		return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-	      }
-	      tmpmaps->name=zStrdup("missingIndetifier");
-	      tmpmaps->content=createMap((char*)cur2->name,(char*)val);
-	      tmpmaps->next=NULL;
-	    }
-	    else{
-	      if(tmpmaps->content!=NULL)
-		addToMap(tmpmaps->content,
-			 (char*)cur2->name,(char*)val);
-	      else
-		tmpmaps->content=
-		  createMap((char*)cur2->name,(char*)val);
-	    }
-#ifdef DEBUG
-	    dumpMaps(tmpmaps);
-#endif
-	    xmlFree(val);
-	  }
-	  /**
+                  if (xmlStrncasecmp
+                      (cur2->name, BAD_CAST "Title",
+                       xmlStrlen (cur2->name)) == 0
+                      || xmlStrncasecmp (cur2->name, BAD_CAST "Abstract",
+                                         xmlStrlen (cur2->name)) == 0)
+                    {
+                      xmlChar *val =
+                        xmlNodeListGetString (doc, cur2->xmlChildrenNode, 1);
+                      if (tmpmaps == NULL)
+                        {
+                          tmpmaps = (maps *) malloc (MAPS_SIZE);
+                          if (tmpmaps == NULL)
+                            {
+                              return errorException (m,
+                                                     _
+                                                     ("Unable to allocate memory."),
+                                                     "InternalError", NULL);
+                            }
+                          tmpmaps->name = zStrdup ("missingIndetifier");
+                          tmpmaps->content =
+                            createMap ((char *) cur2->name, (char *) val);
+                          tmpmaps->next = NULL;
+                        }
+                      else
+                        {
+                          if (tmpmaps->content != NULL)
+                            addToMap (tmpmaps->content,
+                                      (char *) cur2->name, (char *) val);
+                          else
+                            tmpmaps->content =
+                              createMap ((char *) cur2->name, (char *) val);
+                        }
+#ifdef DEBUG
+                      dumpMaps (tmpmaps);
+#endif
+                      xmlFree (val);
+                    }
+          /**
 	   * InputDataFormChoice (Reference or Data ?) 
 	   */
-	  if(xmlStrcasecmp(cur2->name,BAD_CAST "Reference")==0){
-	    /**
+                  if (xmlStrcasecmp (cur2->name, BAD_CAST "Reference") == 0)
+                    {
+            /**
 	     * Get every attribute from a Reference node
 	     * mimeType, encoding, schema, href, method
